import java.util.*;

public class DataServer
{
   private Hashtable data = new Hashtable();

   public Object get (String key)
   {
      Object obj = data.get (key);
      if (obj == null)
      {
         System.out.print (key + " ");
         try
         {
            // simulate getting lots of data
            obj = new Double[1000000];
            data.put (key, obj);
         }
         catch (OutOfMemoryError e)
         {
            System.out.print ("\nNo Memory! ");
            flushCache();
            obj = get (key);    // try again
         }
      }
      return (obj);
   }

   public void flushCache()
   {
      System.out.println ("Clearing cache");
      data.clear();
   }
   
   public static void main (String[] args)
   {
      DataServer ds = new DataServer();
      int count = 0;
      while (true) // infinite loop for test
         ds.get ("" + count++);
   }
}
