/* CreateTestFiles.java */
package jwiley.effective;

import java.util.*;
import java.io.*;

public class CreateTestFile
{
    public static void main(String args[]) throws IOException
    {
        if (args.length < 2)
        {
            System.out.println("USAGE: java jwiley.effective.CreateTestFile filename #_of_lines #_of_char_per_line");
            System.exit(1);
        }

        String filename = args[0];
        int iLines = Integer.parseInt(args[1]);
        int iChars = Integer.parseInt(args[2]);

        Random dice = new Random();
        FileOutputStream fos = new FileOutputStream(filename);
        PrintWriter pw = new PrintWriter(fos);
        for (int i=0; i < iLines; i++)
        {
            StringBuffer sb = new StringBuffer();
            int randomNumChars = Math.abs(dice.nextInt() % iChars);
            for (int j=0; j < randomNumChars; j++)
            {
                char c = (char) (65 + Math.abs(dice.nextInt() % 26));
                int roll = Math.abs(dice.nextInt() % 100);
                if (roll < 25)  // 25% of the time put a space
                    sb.append(' ');
                else
                    sb.append(c);
            }
            int roll2 = Math.abs(dice.nextInt() % 100);
            if (roll2 > 50) // flip a coint
                sb.insert(0,'#');
            pw.println(sb.toString());
        }
        fos.close();
        System.out.println("Wrote " + filename);
    }
}
