/**
 *  Item 21: Properties Object Pitfalls
 */

import java.util.Properties;
import java.io.IOException;
import java.io.InputStream;

public class PropertyLoader
{
   //cant instantiate outside this class.
   private PropertyLoader() {}

   public static Properties load(String propName)
   {
      try
      {
         InputStream is = PropertyLoader.class.getResourceAsStream(propName);
         if (is != null)
         {
            Properties props = new Properties();
            props.load(is);
            return props;
         }
      }
      catch (IOException ioe) {} // handle exception
      return null;
   }
}
