import java.util.Hashtable;

public class Clone1mod
{
    public static void main (String args[])
    {
        // Farmer Bob's perfect sheep
        Sheep sheep1 = new Sheep("Wooly", "Farmer Bob",
                            "White w/Black Patches", 123.7f);

        // sell a copy to Farmer Rick
        Sheep sheep2 = (Sheep) sheep1.clone();
        sheep2.setOwnerName("Farmer Rick");

        sheep2.name = "Patch";    // Farmer Rick renames sheep
        sheep2.setWeight(149.2f);   // feeds it day and night
        sheep2.setColor("Purple");  // and dyes its coat

        // the results
        System.out.println("Sheep1:\n" + sheep1.toString());
        System.out.println("\nSheep2:\n" + sheep2.toString());
    }
}

class Sheep implements Cloneable
{
    public  String      name;
    private Person      owner = new Person();
    private Hashtable   attributes = new Hashtable();

    public Sheep (String name, String ownerName,
                    String color, float weight)
    {
        this.name = name;
        this.setOwnerName(ownerName);
        this.setColor(color);
        this.setWeight(weight);
    }

    public String getOwnerName ()
    {   return (owner.name); }

    public void setOwnerName (String ownerName)
    {   owner.name = ownerName;  }

    public String getColor ()
    {   return ((String)attributes.get("Color"));   }

    public void setColor (String color)
    {   attributes.put("Color", color);    }

    public float getWeight ()
    {
        return (((Float) attributes.get("Weight")).floatValue());
    }

    public void setWeight (float weight)
    {   attributes.put("Weight", new Float(weight));   }

    public Object clone ()
    {
        try
        {
            Sheep newSheep = (Sheep) super.clone();
            newSheep.owner = (Person) this.owner.clone();
            newSheep.attributes = (Hashtable) this.attributes.clone();
            return (newSheep);
        }
        catch (CloneNotSupportedException e)
        {
            throw new InternalError();
        }
    }

    public String toString ()
    {
        return ("Name: " + this.name +
                "\nOwner: " + this.getOwnerName() +
                "\nColor: " + this.getColor() +
                "\nWeight: " + this.getWeight());
    }
}

class Person implements Cloneable
{
    public String name;

    public Object clone()
    {
        try
        {
            return (super.clone());
        }
        catch (CloneNotSupportedException cnse)
        {
            throw new InternalError();
        }
    }
}