import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class BasicSearch2 extends JFrame implements ActionListener
{
    JLabel       searchLabel = new JLabel("Find:");
    JTextField   searchTextField = new JTextField(20);
    JLabel       resultsLabel = new JLabel("Results:");
    JList        results = new JList();

    JButton      searchButton = new JButton("Search");
    JButton      cancelButton = new JButton("Cancel");
    SearchWorker    searchWorker;

    static String[] words = { "ace", "race", "mace", "pace",
                             "chase", "rice", "splice", "mice",
                             "diced", "price", "lime", "dime" };

    public BasicSearch2 (String title)
    {
        super(title);

        JPanel searchPanel = new JPanel();
        JPanel resultsPanel = new JPanel();
        JPanel buttonPanel = new JPanel();

        results.setModel(new DefaultListModel());

        getContentPane().setLayout(new BorderLayout());
        searchPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
        resultsPanel.setLayout(new BorderLayout());
        buttonPanel.setLayout(new FlowLayout(FlowLayout.CENTER));

        searchPanel.add(searchLabel);
        searchPanel.add(searchTextField);

        resultsPanel.add("North", resultsLabel);
        resultsPanel.add("Center", results);

        buttonPanel.add(searchButton);
        buttonPanel.add(cancelButton);

        searchButton.addActionListener(this);
        cancelButton.addActionListener(this);
        cancelButton.setEnabled(false);

        getContentPane().add("North", searchPanel);
        getContentPane().add("Center", resultsPanel);
        getContentPane().add("South", buttonPanel);

        this.setSize(300,300);
        this.setVisible(true);
    }

    public void actionPerformed (ActionEvent evt)
    {
        Object source = evt.getSource();

        if (source == searchButton)
        {
            searchButton.setEnabled(false);
            cancelButton.setEnabled(true);
            results.removeAll();
            searchWorker =
                new SearchWorker(this, searchTextField.getText());
        }
        else if (source == cancelButton)
        {
            searchWorker.interrupt();
        }
    }

    public static void main (String args[])
    {
        new BasicSearch2("Basic Search");
    }
}

class SearchWorker extends SwingWorker
{
    BasicSearch2 basicSearch2;
    String       searchText;

    public SearchWorker (BasicSearch2 basicSearch2,
                                        String searchText)
    {
        this.basicSearch2 = basicSearch2;
        this.searchText = searchText;
    }

    public Object construct()
    {
        for (int i = 0; i < basicSearch2.words.length; i++)
        {
            try
            {
        		if (Thread.interrupted())
    	    	    throw new InterruptedException();

                Thread.sleep(1000);
                if (basicSearch2.words[i].indexOf(searchText) != -1)
                {
                    DefaultListModel model = (DefaultListModel)
                                     basicSearch2.results.getModel();
                    model.addElement(basicSearch2.words[i]);
                }
            }
	        catch (InterruptedException ie)
	        {
        	    return ("Interrupted");
        	}
        }
        return ("Done");
    }

    public void finished()
    {
        basicSearch2.searchButton.setEnabled(true);
        basicSearch2.cancelButton.setEnabled(false);
    }
}
