import java.awt.datatransfer.*;
import java.awt.*;
import java.util.*;

public class PrintFlavorMapping
{
    public static void main (String args[])
    {
        FlavorMap flavorMap = SystemFlavorMap.getDefaultFlavorMap();
        Iterator it = (flavorMap.getFlavorsForNatives(null)).entrySet().iterator();

        while (it.hasNext())
        {
            Map.Entry entry = (Map.Entry) it.next();
            System.out.println("native: " + entry.getKey() + ", flavor: " + entry.getValue());
        }

        Iterator it2 = (flavorMap.getNativesForFlavors(null)).entrySet().iterator();

        while (it2.hasNext())
        {
            Map.Entry entry = (Map.Entry) it2.next();
            System.out.println("flavor: " + entry.getKey() + ", native: " + entry.getValue());
        }

        System.out.println();
        System.out.println("StringSelection DataFlavors:");

        StringSelection ss = new StringSelection("Hello");
        DataFlavor[] ssFlavors = ss.getTransferDataFlavors();
        for (int i = 0; i < ssFlavors.length; i++)
        {
            System.out.println(ssFlavors[i].getMimeType());
        }

        System.out.println();
        System.out.println("DataFlavor.plainTextFlavor:");
        System.out.println(DataFlavor.plainTextFlavor.getMimeType());
        System.out.println(DataFlavor.stringFlavor.getMimeType());

        System.out.println(Toolkit.getDefaultToolkit().getSystemClipboard().getClass().getName());

        Transferable t = Toolkit.getDefaultToolkit().getSystemClipboard().getContents(null);
        if (t == null)
            System.out.println("Transferable is null");
        else
        {
            DataFlavor[] df = t.getTransferDataFlavors();
            for (int i = 0; i < df.length; i++)
                System.out.println(df[i].getMimeType());
        }


        System.exit(1);

    }
}
