#include <windows.h>
#include "NativeExtendedClipboard.h"
#include "NativeExtendedTransferable.h"

#define PALETTE_SIZE	256

typedef struct _JavaBitmapData
{
	int		width;
	int		height;
	int		pixels[1];
} JavaBitmapData;

UINT	newRegisteredFormat = 0;

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    return TRUE;
}
/*
JNIEXPORT jint JNICALL Java_NativeExtendedClipboard_registerNewFlavor
  (JNIEnv *pEnv, jobject pObject, jstring formatDescription)
{
	const char	*ccpFormatDescription;
	UINT		format;

	ccpFormatDescription = (*pEnv)->GetStringUTFChars(pEnv, formatDescription, 0);
	format = RegisterClipboardFormat(ccpFormatDescription);
	newRegisteredFormat = format;
	(*pEnv)->ReleaseStringUTFChars(pEnv, formatDescription, ccpFormatDescription);

	return (format);
}
*/
JNIEXPORT void JNICALL Java_NativeExtendedClipboard_setNativeClipboardData
  (JNIEnv *pEnv, jobject pObject, jint format, jbyteArray data)
{
	DWORD		dwNumBytes;
	HGLOBAL		handle;
	char		*localData;
	char		*javaData;
	jboolean	isCopy = FALSE;
	
	JavaBitmapData		*javaBitmapData;
	BITMAPINFOHEADER	*bitmapHeader;
	RGBQUAD				*colorTable;
	char				*bitmapData;

	unsigned char		red;
	unsigned char		blue;
	unsigned char		green;
	unsigned char	    alpha;
	int					width;
	int					height;
	//int					numPixels;
	int					xwidth, y, xy, z;
	int					numColors = 0;
	BOOL				colorMatch = FALSE;
	int					i, j, k;

	if (OpenClipboard(NULL))
	{
		if (format == CF_DIB)
		{
			javaData = (*pEnv)->GetByteArrayElements(pEnv, data, &isCopy);
			javaBitmapData = (JavaBitmapData *) javaData;

			width = javaBitmapData->width;
			height = javaBitmapData->height;
			if (width % sizeof(DWORD) == 0)
				xwidth = width; 
			else
				xwidth = width + (sizeof(DWORD) - (width % sizeof(DWORD)));

			handle = GlobalAlloc(GMEM_MOVEABLE | GMEM_DDESHARE, (xwidth * height) + sizeof(BITMAPINFOHEADER) + (PALETTE_SIZE * sizeof(RGBQUAD)));
			bitmapHeader = (BITMAPINFOHEADER *) GlobalLock(handle);
			bitmapHeader->biSize = sizeof(BITMAPINFOHEADER);
			bitmapHeader->biWidth = javaBitmapData->width;
			bitmapHeader->biHeight = javaBitmapData->height;
			bitmapHeader->biPlanes = 1;
			bitmapHeader->biBitCount = 8;
			bitmapHeader->biCompression = BI_RGB;
			bitmapHeader->biSizeImage = 0;
			bitmapHeader->biXPelsPerMeter = 0;
			bitmapHeader->biYPelsPerMeter = 0;
			bitmapHeader->biClrUsed = 0;
			bitmapHeader->biClrImportant = 0;

			// set up pointers into allocated memory
			colorTable = (RGBQUAD*) (((char*)bitmapHeader) + sizeof(BITMAPINFOHEADER));
			bitmapData = (char*) (colorTable + PALETTE_SIZE);

			// create color table and assign bitmap data - make a fixed 256 color table

			//DEM-fix flipped image - start filling in pixels from bottom left to top right (currently filling in bottom right to top left)
			for (i = 0; i < height; i++)
			{
				for (j = 0; j < width; j++)
				{
					y = (i * width) + j;
					xy = (i * xwidth) + j;
					red = (char) (javaBitmapData->pixels[y] >> 8);
					green = (char)(javaBitmapData->pixels[y] >> 16);
					blue = (char) (javaBitmapData->pixels[y] >> 24);
					alpha = (char) (javaBitmapData->pixels[y]);

					colorMatch = FALSE;
					for (k = 0; k < numColors; k++)
					{
						if ((colorTable + k)->rgbBlue == blue && 
							(colorTable + k)->rgbGreen == green &&
							(colorTable + k)->rgbRed == red)
						{
							//bitmapData[numPixels - (i + 1)] = (char) k;
							z = xy + xwidth * (height - (1 + (2 * i)));
							bitmapData[z] = (char) k;
							colorMatch = TRUE;
							break;
						}
					}

					if (!colorMatch)
					{
						//bitmapData[numPixels - (i + 1)] = (char) numColors;
						z = xy + xwidth * (height - (1 + (2 * i)));
						bitmapData[z] = (char) numColors;
						(colorTable + numColors)->rgbBlue = blue;
						(colorTable + numColors)->rgbGreen = green;
						(colorTable + numColors)->rgbRed = red;
						(colorTable + numColors)->rgbReserved = 0;
						numColors++;
					}
				}
			}
			(*pEnv)->ReleaseByteArrayElements(pEnv, data, javaData, JNI_ABORT);
			GlobalUnlock(handle);
		}
		else
		{
			dwNumBytes = (*pEnv)->GetArrayLength(pEnv, data);
			handle = GlobalAlloc(GMEM_MOVEABLE | GMEM_DDESHARE, dwNumBytes);
			localData = (char *) GlobalLock(handle);

			javaData = (*pEnv)->GetByteArrayElements(pEnv, data, &isCopy);
			memcpy(localData, javaData, dwNumBytes);

			(*pEnv)->ReleaseByteArrayElements(pEnv, data, javaData, JNI_ABORT);
			GlobalUnlock(handle);
		}

		EmptyClipboard();
		SetClipboardData(format, handle);
		CloseClipboard();
	}
}

JNIEXPORT jintArray JNICALL Java_NativeExtendedClipboard_getFormats
  (JNIEnv *pEnv, jobject pObject)
{
	jintArray	returnFormats;
	int			localFormats[100];
	int			numFormats = 0;
	int			previousFormat = 0;

	if (OpenClipboard(NULL))
	{
		while (TRUE)
		{
			localFormats[numFormats] = EnumClipboardFormats(previousFormat);
			if (localFormats[numFormats] == 0)
				break;

			previousFormat = localFormats[numFormats];
			numFormats++;
		}
		returnFormats = (*pEnv)->NewIntArray(pEnv, numFormats);
		(*pEnv)->SetIntArrayRegion(pEnv, returnFormats, 0, numFormats, localFormats);
 
		CloseClipboard();

		return (returnFormats);
	}
	else
		return (NULL);
}

JNIEXPORT jbyteArray JNICALL Java_NativeExtendedClipboard_getBytes
  (JNIEnv *pEnv, jobject pObject, jint format)
{
	HGLOBAL		handle;
	jbyteArray	returnData = NULL;
	DWORD		dwNumBytes;
	char		*localData;

	BITMAPINFOHEADER	*bitmapHeader;
	int					colorTableSize = 0;
	RGBQUAD				*colorTable;
	unsigned int		colorTableIndex = 0;
	int					bitmapDataIndex = 0;
	RGBQUAD				currentNativePixel;
	char				*bitmapData;
	int					height;
	int					width;
	int					xwidth;
	int					numPixels;
	int					pixelIndex;
	//unsigned char		red;
	//unsigned char		blue;
	//unsigned char		green;
	int					i, j;
	int					xy, z;
	unsigned char		alpha;

	if (OpenClipboard(NULL))
	{
		handle = GetClipboardData(format);
		if (handle != NULL)
		{
			if (format == CF_DIB)
			{
				bitmapHeader = (BITMAPINFOHEADER *) GlobalLock(handle);
				if (bitmapHeader->biSize == sizeof(BITMAPINFOHEADER))
				{
					width = bitmapHeader->biWidth;
					height = bitmapHeader->biHeight;

					if (width % sizeof(DWORD) == 0)
						xwidth = width; 
					else
						xwidth = width + (sizeof(DWORD) - (width % sizeof(DWORD)));

					numPixels = width * height;
					colorTable = (RGBQUAD*) (((char*)bitmapHeader) + sizeof(BITMAPINFOHEADER));
					colorTableSize = 1 << bitmapHeader->biBitCount;
					bitmapData = (char*) (colorTable + colorTableSize);
					returnData = (*pEnv)->NewByteArray(pEnv, sizeof(JavaBitmapData) + (numPixels - 1) * sizeof(int));

					(*pEnv)->SetByteArrayRegion(pEnv, returnData, 0, 4, (char*)&width);
					(*pEnv)->SetByteArrayRegion(pEnv, returnData, 4, 4, (char*)&height);
					//(*pEnv)->SetByteArrayRegion(pEnv, returnData, 8, 4, (char*)&numPixels);

					// do the following - fix scan line sizing problem - make sure ints are being passed correctly as bytes
					// fix negative num pixels on flip side
					pixelIndex = 8;
					alpha = 255;
					for (i = 0; i < height; i++)
					{
						for (j = 0; j < width; j++)
						{
							//y = (i * width) + j;
							xy = (i * xwidth) + j;

							//bitmapDataIndex = numPixels - (height * (i + 1)) + j;
							z = xy + xwidth * (height - (1 + (2 * i)));
							//bitmapData[z] = (char) k;

							//colorTableIndex = (unsigned int) bitmapData[bitmapDataIndex];
							colorTableIndex = (unsigned int) bitmapData[z];
							currentNativePixel = colorTable[colorTableIndex];
							(*pEnv)->SetByteArrayRegion(pEnv, returnData, pixelIndex + 3, 1, (char*)&(alpha));
							(*pEnv)->SetByteArrayRegion(pEnv, returnData, pixelIndex + 2, 1, (char*)&(currentNativePixel.rgbRed));
							(*pEnv)->SetByteArrayRegion(pEnv, returnData, pixelIndex + 1, 1, (char*)&(currentNativePixel.rgbGreen));
							(*pEnv)->SetByteArrayRegion(pEnv, returnData, pixelIndex, 1, (char*)&(currentNativePixel.rgbBlue));
							pixelIndex += 4;
						}
					}
				}
				else
				{
					// unknown bitmap flavor
					return (NULL);
				}
			}
			else if ((UINT)format == newRegisteredFormat && newRegisteredFormat != 0)
			{
				dwNumBytes = GlobalSize(handle);
				if (dwNumBytes != 0)
				{
					returnData = (*pEnv)->NewByteArray(pEnv, dwNumBytes);
					localData = (char *) GlobalLock(handle);
					(*pEnv)->SetByteArrayRegion(pEnv, returnData, 0, dwNumBytes, localData);
					GlobalUnlock(handle);
				}
			}
			else
			{
				return (NULL);
			}
		}

		CloseClipboard();
	}

	return (returnData);
}

