
import java.awt.*;
import java.util.*;

public class Item46_4
{
    private static int  listSize;
    private static long elapsedTime;

    public static void main (String args[])
    {
        listSize = Integer.parseInt(args[0]);
        displayLookupList(loadLookupData());
    }

    private static void displayLookupList (int items[])
    {
        Frame f = new Frame("Performance Contest");
        f.setLayout(new BorderLayout());

        Label time = new Label("Time to load " + items.length +
                               " item list: " + elapsedTime + " ms");
        java.awt.List displayList = new java.awt.List();
        for (int i = 0; i < items.length; i++)
            displayList.add("" + items[i]);

        f.add("North", time);
        f.add("Center", displayList);
        f.setSize(400,400);
        f.setVisible(true);
    }

    private static int[] loadLookupData ()
    {
        IntEnumeration preloadedData = getPreloadedData();
        int[] lookupData = null;
        Vector   temp = new Vector();

        Date startTime = new Date();
        while (preloadedData.hasMoreElements())
        {
            temp.addElement(new Integer((int) preloadedData.nextElement()));
        }
        int iNumElements = temp.size();
        lookupData = new int[iNumElements];
        for (int i = 0; i < iNumElements; i++)
            lookupData[i] = ((Integer)temp.elementAt(i)).intValue();
        Date stopTime = new Date();
        elapsedTime = stopTime.getTime() - startTime.getTime();
        System.out.println("Elapsed time: " + elapsedTime + " ms");
        return (lookupData);
    }

    private static IntEnumeration getPreloadedData ()
    {
        int preloadedData[] = new int[listSize];
        for (int i = 0; i < listSize; i++)
            preloadedData[i] = (i * 100);

        return (new IntEnumeration(preloadedData));
    }
}

class IntEnumeration
{
    int count = -1;
    int elements[];

    public IntEnumeration (int[] elements)
    {
        this.elements = elements;
    }

    public boolean hasMoreElements()
    {
        return (count < (elements.length - 1));
    }

    public int nextElement()
    {
        count++;
        return (elements[count]);
    }
}

